<script setup>
definePageMeta({
  middleware: "auth"
})

defineShortcuts({
  '/': () => {
    //console.log(searchinput)
    //searchinput.value.focus()
    document.getElementById("searchinput").focus()
  },
  '+': () => {
    router.push("/projects/create")
  },
  'Enter': {
    usingInput: true,
    handler: () => {
      router.push(`/projecttypes/show/${filteredRows.value[selectedItem.value].id}`)
    }
  },
  'arrowdown': () => {
    if(selectedItem.value < filteredRows.value.length - 1) {
      selectedItem.value += 1
    } else {
      selectedItem.value = 0
    }
  },
  'arrowup': () => {
    if(selectedItem.value === 0) {
      selectedItem.value = filteredRows.value.length - 1
    } else {
      selectedItem.value -= 1
    }
  }
})


const router = useRouter()


const items = ref([])
const selectedItem = ref(0)


const setup = async () => {
    items.value = await useSupabaseSelect("projecttypes","*")
}

setup()

const templateColumns = [
  {
    key: "name",
    label: "Name"
  },

]
const selectedColumns = ref(templateColumns)
const columns = computed(() => templateColumns.filter((column) => selectedColumns.value.includes(column)))

const searchString = ref("")

const filteredRows = computed(() => {
  return useListFilter(searchString.value, items.value)
})

</script>

<template>
  <UDashboardNavbar title="Projekttypen" :badge="filteredRows.length">
    <template #right>
      <UInput
          id="searchinput"
          v-model="searchString"
          icon="i-heroicons-funnel"
          autocomplete="off"
          placeholder="Suche..."
          class="hidden lg:block"
          @keydown.esc="$event.target.blur()"
      >
        <template #trailing>
          <UKbd value="/" />
        </template>
      </UInput>

      <UButton @click="router.push(`/projecttypes/create`)">+ Projekttyp</UButton>
    </template>
  </UDashboardNavbar>

  <UTable
      :rows="filteredRows"
      :columns="columns"
      class="w-full"
      :ui="{ divide: 'divide-gray-200 dark:divide-gray-800' }"
      @select="(i) => router.push(`/projecttypes/show/${i.id}`) "
      :empty-state="{ icon: 'i-heroicons-circle-stack-20-solid', label: 'Keine Projekttypen anzuzeigen' }"
  >
    <template #name-data="{row}">
      <span class="text-primary-500 font-bold" v-if="row === filteredRows[selectedItem]">{{row.name}}</span>
      <span v-else>{{row.name}}</span>
    </template>

  </UTable>
</template>

<style scoped>

</style>